﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls;
using Telerik.WinControls.UI;

namespace SchedulerBindToDatabaseCSharp
{
    public partial class RadForm1 : Telerik.WinControls.UI.RadForm
    {
        public RadForm1()
        {
            InitializeComponent();
        }

        private void RadForm1_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'dataFlowSchedDataSet.Resources' table. You can move, or remove it, as needed.
            this.resourcesTableAdapter.Fill(this.dataFlowSchedDataSet.Resources);
            // TODO: This line of code loads data into the 'dataFlowSchedDataSet.AppointmentsResources' table. You can move, or remove it, as needed.
            this.appointmentsResourcesTableAdapter.Fill(this.dataFlowSchedDataSet.AppointmentsResources);
            // TODO: This line of code loads data into the 'dataFlowSchedDataSet.Appointments' table. You can move, or remove it, as needed.
            this.appointmentsTableAdapter.Fill(this.dataFlowSchedDataSet.Appointments);

            AppointmentMappingInfo appointmentMappingInfo = new AppointmentMappingInfo();
            appointmentMappingInfo.BackgroundId = "BackgroundID";
            appointmentMappingInfo.Description = "Description";
            appointmentMappingInfo.End = "End";
            appointmentMappingInfo.Location = "Location";
            appointmentMappingInfo.MasterEventId = "ParentID";
            appointmentMappingInfo.RecurrenceRule = "RecurrenceRule";
            appointmentMappingInfo.ResourceId = "ResourceID";
            appointmentMappingInfo.Exceptions = "Appointments_Appointments";
            appointmentMappingInfo.Resources = "Appointments_AppointmentsResources";
            appointmentMappingInfo.Start = "Start";
            appointmentMappingInfo.StatusId = "StatusID";
            appointmentMappingInfo.Summary = "Summary";
            schedulerBindingDataSource1.EventProvider.Mapping = appointmentMappingInfo;
            ResourceMappingInfo resourceMappingInfo = new ResourceMappingInfo();
            resourceMappingInfo.Id = "ID";
            resourceMappingInfo.Name = "ResourceName";
            this.schedulerBindingDataSource1.ResourceProvider.Mapping = resourceMappingInfo;
            schedulerBindingDataSource1.ResourceProvider.DataSource = dataFlowSchedDataSet.Resources;
            schedulerBindingDataSource1.EventProvider.DataSource = dataFlowSchedDataSet.Appointments;

            radScheduler1.DataSource = schedulerBindingDataSource1;
            
            this.radScheduler1.GroupType = GroupType.Resource;

            SchedulerMapping mapping = appointmentMappingInfo.FindBySchedulerProperty("ResourceId");
            mapping.ConvertToScheduler = new ConvertCallback(ConvertResourceIdToScheduler);
            mapping.ConvertToDataSource = new ConvertCallback(ConvertResourceIdToDataSource);

           this.radScheduler1.AppointmentChanged += RadScheduler1_AppointmentChanged;
        }
         
        private void RadScheduler1_AppointmentChanged(object sender, AppointmentChangedEventArgs e)
        {
            IEditableObject editableObject = e.Appointment.DataItem as IEditableObject;
            if (editableObject!=null)
            {
                editableObject.EndEdit();
            }
            SaveChanges();
        }

        object ConvertResourceIdToScheduler(object obj)
        {
            if (!(obj is DBNull))
            {
                return new EventId((int)obj);
            }
            return null;
        }

        object ConvertResourceIdToDataSource(object obj)
        {
            EventId resourceId = (EventId)obj;
            if (resourceId != null)
            {
                return resourceId.KeyValue;
            }
            return -1;
        }

        private void radButton1_Click(object sender, EventArgs e)
        {
            SaveChanges();
        }
 
        private void SaveChanges()
        { 
            DataFlowSchedDataSet.AppointmentsResourcesDataTable deletedRelationRecords =
                this.dataFlowSchedDataSet.AppointmentsResources.GetChanges(DataRowState.Deleted)
                as DataFlowSchedDataSet.AppointmentsResourcesDataTable;
            DataFlowSchedDataSet.AppointmentsResourcesDataTable newRelationRecords =
                this.dataFlowSchedDataSet.AppointmentsResources.GetChanges(DataRowState.Added)
                as DataFlowSchedDataSet.AppointmentsResourcesDataTable;
            DataFlowSchedDataSet.AppointmentsResourcesDataTable modifiedRelationRecords =
                this.dataFlowSchedDataSet.AppointmentsResources.GetChanges(DataRowState.Modified)
                as DataFlowSchedDataSet.AppointmentsResourcesDataTable;
            DataFlowSchedDataSet.AppointmentsDataTable newAppointmentRecords =
                this.dataFlowSchedDataSet.Appointments.GetChanges(DataRowState.Added) as DataFlowSchedDataSet.AppointmentsDataTable;
            DataFlowSchedDataSet.AppointmentsDataTable deletedAppointmentRecords =
                this.dataFlowSchedDataSet.Appointments.GetChanges(DataRowState.Deleted) as DataFlowSchedDataSet.AppointmentsDataTable;
            DataFlowSchedDataSet.AppointmentsDataTable modifiedAppointmentRecords =
                this.dataFlowSchedDataSet.Appointments.GetChanges(DataRowState.Modified) as DataFlowSchedDataSet.AppointmentsDataTable;
            try
            {
                if (newAppointmentRecords != null)
                {
                    Dictionary<int, int> newAppointmentIds = new Dictionary<int, int>();
                    Dictionary<object, int> oldAppointmentIds = new Dictionary<object, int>();
                    for (int i = 0; i < newAppointmentRecords.Count; i++)
                    {
                        oldAppointmentIds.Add(newAppointmentRecords[i], newAppointmentRecords[i].ID);
                    }
                    appointmentsTableAdapter.Update(newAppointmentRecords);
                    for (int i = 0; i < newAppointmentRecords.Count; i++)
                    {
                        newAppointmentIds.Add(oldAppointmentIds[newAppointmentRecords[i]], newAppointmentRecords[i].ID);
                    }
                    if (newRelationRecords != null)
                    {
                        for (int i = 0; i < newRelationRecords.Count; i++)
                        {
                            newRelationRecords[i].AppointmentID = newAppointmentIds[newRelationRecords[i].AppointmentID];
                        }
                    }
                }
                if (deletedRelationRecords != null)
                {
                    appointmentsResourcesTableAdapter.Update(deletedRelationRecords);
                }
                if (deletedAppointmentRecords != null)
                {
                    appointmentsTableAdapter.Update(deletedAppointmentRecords);
                }
                if (modifiedAppointmentRecords != null)
                {
                    appointmentsTableAdapter.Update(modifiedAppointmentRecords);
                }
                if (newRelationRecords != null)
                {
                    appointmentsResourcesTableAdapter.Update(newRelationRecords);
                }
                if (modifiedRelationRecords != null)
                {
                    appointmentsResourcesTableAdapter.Update(modifiedRelationRecords);
                }
                this.dataFlowSchedDataSet.AcceptChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(string.Format("An error occurred during the update process:\n{0}", ex.Message));
            }
            finally
            {
                if (deletedRelationRecords != null)
                {
                    deletedRelationRecords.Dispose();
                }
                if (newRelationRecords != null)
                {
                    newRelationRecords.Dispose();
                }
                if (modifiedRelationRecords != null)
                {
                    modifiedRelationRecords.Dispose();
                }
            }
        }
    }
}